import math

import numpy as np

def threespheres(a1, a2, a3, b1, b2, b3, c1, c2, c3, d14, d24, d34):
	S1 = np.zeros(32)
	S1[1] = a1 # e1
	S1[2] = a2 # e2
	S1[3] = a3 # e3
	S1[4] = (-((d14 * d14) / 2.0)) + (a3 * a3) / 2.0 + (a2 * a2) / 2.0 + (a1 * a1) / 2.0 # einf
	S1[5] = 1.0 # e0
	S2 = np.zeros(32)
	S2[1] = b1 # e1
	S2[2] = b2 # e2
	S2[3] = b3 # e3
	S2[4] = (-((d24 * d24) / 2.0)) + (b3 * b3) / 2.0 + (b2 * b2) / 2.0 + (b1 * b1) / 2.0 # einf
	S2[5] = 1.0 # e0
	S3 = np.zeros(32)
	S3[1] = c1 # e1
	S3[2] = c2 # e2
	S3[3] = c3 # e3
	S3[4] = (-((d34 * d34) / 2.0)) + (c3 * c3) / 2.0 + (c2 * c2) / 2.0 + (c1 * c1) / 2.0 # einf
	S3[5] = 1.0 # e0
	PP4 = np.zeros(32)
	PP4[16] = (S1[1] * S2[2] - S1[2] * S2[1]) * S3[3] + (S1[3] * S2[1] - S1[1] * S2[3]) * S3[2] + (S1[2] * S2[3] - S1[3] * S2[2]) * S3[1] # e1 ^ (e2 ^ e3)
	PP4[17] = (S1[1] * S2[2] - S1[2] * S2[1]) * S3[4] + (S1[4] * S2[1] - S1[1] * S2[4]) * S3[2] + (S1[2] * S2[4] - S1[4] * S2[2]) * S3[1] # e1 ^ (e2 ^ einf)
	PP4[18] = (S2[1] - S1[1]) * S3[2] + (S1[2] - S2[2]) * S3[1] + S1[1] * S2[2] - S1[2] * S2[1] # e1 ^ (e2 ^ e0)
	PP4[19] = (S1[1] * S2[3] - S1[3] * S2[1]) * S3[4] + (S1[4] * S2[1] - S1[1] * S2[4]) * S3[3] + (S1[3] * S2[4] - S1[4] * S2[3]) * S3[1] # e1 ^ (e3 ^ einf)
	PP4[20] = (S2[1] - S1[1]) * S3[3] + (S1[3] - S2[3]) * S3[1] + S1[1] * S2[3] - S1[3] * S2[1] # e1 ^ (e3 ^ e0)
	PP4[21] = (S2[1] - S1[1]) * S3[4] + (S1[4] - S2[4]) * S3[1] + S1[1] * S2[4] - S1[4] * S2[1] # e1 ^ (einf ^ e0)
	PP4[22] = (S1[2] * S2[3] - S1[3] * S2[2]) * S3[4] + (S1[4] * S2[2] - S1[2] * S2[4]) * S3[3] + (S1[3] * S2[4] - S1[4] * S2[3]) * S3[2] # e2 ^ (e3 ^ einf)
	PP4[23] = (S2[2] - S1[2]) * S3[3] + (S1[3] - S2[3]) * S3[2] + S1[2] * S2[3] - S1[3] * S2[2] # e2 ^ (e3 ^ e0)
	PP4[24] = (S2[2] - S1[2]) * S3[4] + (S1[4] - S2[4]) * S3[2] + S1[2] * S2[4] - S1[4] * S2[2] # e2 ^ (einf ^ e0)
	PP4[25] = (S2[3] - S1[3]) * S3[4] + (S1[4] - S2[4]) * S3[3] + S1[3] * S2[4] - S1[4] * S2[3] # e3 ^ (einf ^ e0)
	DualPP4 = np.zeros(32)
	DualPP4[6] = (-PP4[25]) # e1 ^ e2
	DualPP4[7] = PP4[24] # e1 ^ e3
	DualPP4[8] = (-PP4[22]) # e1 ^ einf
	DualPP4[9] = PP4[23] # e1 ^ e0
	DualPP4[10] = (-PP4[21]) # e2 ^ e3
	DualPP4[11] = PP4[19] # e2 ^ einf
	DualPP4[12] = (-PP4[20]) # e2 ^ e0
	DualPP4[13] = (-PP4[17]) # e3 ^ einf
	DualPP4[14] = PP4[18] # e3 ^ e0
	DualPP4[15] = PP4[16] # einf ^ e0
	x4a = np.zeros(32)
	x4a[1] = (DualPP4[9] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) + DualPP4[15] * DualPP4[9] - DualPP4[14] * DualPP4[7] - DualPP4[12] * DualPP4[6]) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1
	x4a[2] = (DualPP4[12] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) + DualPP4[6] * DualPP4[9] + DualPP4[12] * DualPP4[15] - DualPP4[10] * DualPP4[14]) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e2
	x4a[3] = (DualPP4[14] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) + DualPP4[7] * DualPP4[9] + DualPP4[14] * DualPP4[15] + DualPP4[10] * DualPP4[12]) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e3
	x4a[4] = (DualPP4[15] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) + DualPP4[8] * DualPP4[9] + DualPP4[15] * DualPP4[15] + DualPP4[13] * DualPP4[14] + DualPP4[11] * DualPP4[12]) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # einf
	x4a[5] = 1.0 # e0
	x4a[16] = (-(DualPP4[10] * DualPP4[9] - DualPP4[12] * DualPP4[7] + DualPP4[14] * DualPP4[6])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1 ^ (e2 ^ e3)
	x4a[17] = (-(DualPP4[11] * DualPP4[9] - DualPP4[12] * DualPP4[8] + DualPP4[15] * DualPP4[6])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1 ^ (e2 ^ einf)
	x4a[19] = (-(DualPP4[13] * DualPP4[9] - DualPP4[14] * DualPP4[8] + DualPP4[15] * DualPP4[7])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1 ^ (e3 ^ einf)
	x4a[22] = (-(DualPP4[10] * DualPP4[15] - DualPP4[11] * DualPP4[14] + DualPP4[12] * DualPP4[13])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e2 ^ (e3 ^ einf)
	x4b = np.zeros(32)
	x4b[1] = (-(DualPP4[9] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) - DualPP4[15] * DualPP4[9] + DualPP4[14] * DualPP4[7] + DualPP4[12] * DualPP4[6])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1
	x4b[2] = (-(DualPP4[12] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) - DualPP4[6] * DualPP4[9] - DualPP4[12] * DualPP4[15] + DualPP4[10] * DualPP4[14])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e2
	x4b[3] = (-(DualPP4[14] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) - DualPP4[7] * DualPP4[9] - DualPP4[14] * DualPP4[15] - DualPP4[10] * DualPP4[12])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e3
	x4b[4] = (-(DualPP4[15] * math.sqrt(2.0 * DualPP4[8] * DualPP4[9] - DualPP4[7] * DualPP4[7] - DualPP4[6] * DualPP4[6] + DualPP4[15] * DualPP4[15] + 2.0 * DualPP4[13] * DualPP4[14] + 2.0 * DualPP4[11] * DualPP4[12] - DualPP4[10] * DualPP4[10]) - DualPP4[8] * DualPP4[9] - DualPP4[15] * DualPP4[15] - DualPP4[13] * DualPP4[14] - DualPP4[11] * DualPP4[12])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # einf
	x4b[5] = 1.0 # e0
	x4b[16] = (-(DualPP4[10] * DualPP4[9] - DualPP4[12] * DualPP4[7] + DualPP4[14] * DualPP4[6])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1 ^ (e2 ^ e3)
	x4b[17] = (-(DualPP4[11] * DualPP4[9] - DualPP4[12] * DualPP4[8] + DualPP4[15] * DualPP4[6])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1 ^ (e2 ^ einf)
	x4b[19] = (-(DualPP4[13] * DualPP4[9] - DualPP4[14] * DualPP4[8] + DualPP4[15] * DualPP4[7])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e1 ^ (e3 ^ einf)
	x4b[22] = (-(DualPP4[10] * DualPP4[15] - DualPP4[11] * DualPP4[14] + DualPP4[12] * DualPP4[13])) / (DualPP4[9] * DualPP4[9] + DualPP4[14] * DualPP4[14] + DualPP4[12] * DualPP4[12]) # e2 ^ (e3 ^ einf)
	return DualPP4, PP4, S1, S2, S3, x4a, x4b